'use strict';
const microgesture = {
	load: function() {
		const p = Components.classes[ '@mozilla.org/preferences-service;1']
			.getService( Components.interfaces.nsIPrefService)
			.getBranch( 'extensions.microgesture.');
		microgesture.useLinks = p.getBoolPref( 'links');
		addEventListener( 'mousedown', this.mDown);
		addEventListener( 'mouseup', this.mUp);	
		addEventListener( 'contextmenu', this.mContext);
	},
	
	mDown: function( event) {
		if ( event.button == 2) {
			microgesture.originX = event.screenX;
			microgesture.originY = event.screenY;
			let elem = event.target;
			while ( elem.parentNode && ( !elem.href || !microgesture.useLinks)) elem = elem.parentNode;
			microgesture.doc = elem;
		}
	},

	mUp: function( event) {
		if ( event.button == 2) {
			let dir;
			const dX = event.screenX - microgesture.originX;
			const dY = event.screenY - microgesture.originY;
			if ( Math.abs(dX) + Math.abs(dY) > 5 )
			{	if ( Math.abs(dY) > Math.abs(dX))
					dir = (dY>0) ? 'dn' : 'up'
				else
					dir = (dX>0) ? 'rt' : 'lf';
				const where = microgesture.doc;
				const isLink = (microgesture.useLinks && (where.href) && (where.protocol != 'javascript:')); 
				sendAsyncMessage( 'microgesture@snuznet.org', {what: dir, h: where.href, l: isLink} );
			}
			else
			{	const synth = event.target.ownerDocument.createEvent('MouseEvents');
				synth.initMouseEvent( 'contextmenu', true, true,
					event.target.ownerDocument.defaultView, -1, event.screenX, event.screenY);
				event.target.dispatchEvent( synth);
			}
		}
	},

	mContext: function( event) {
		if ( event.detail != -1 ) event.preventDefault();
	}
};
microgesture.load();
